/*
 * com.gregor.rrd.RRDSharedPipe
 *
 * $Id: RRDPipeSingleton.java,v 1.1.1.1 2004/08/17 01:07:04 djgregor Exp $
 *
 * Copyright (c) 2003 Daniel J. Gregor, Jr.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *    - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

package com.gregor.rrd;

import java.io.IOException;
import java.io.OutputStream;

public class RRDPipeSingleton extends RRDTool {
    private static RRDPipe m_singleton = null;

    public RRDPipeSingleton() {
	if (m_singleton == null) {
	    m_singleton = new RRDPipe();
	}
    }

    public RRDPipeSingleton(String RRDTool) {
	this();
	m_singleton.setRRDTool(RRDTool);
    }

    public String getRRDTool() {
	return m_singleton.getRRDTool();
    }
	
    public void setRRDTool(String RRDTool) {
	if (!m_singleton.getRRDTool().equals(RRDTool)) {
	    m_singleton.setRRDTool(RRDTool);
	}
    }

    public void init() throws RRDException, IOException {
	m_singleton.init();
    }

    public void deInit() {
	m_singleton.deInit();
    }

    public String[] doCommand(String[] command, OutputStream out)
	    throws RRDException, IOException {
	return m_singleton.doCommand(command, out);
    }

    public String[] doCommand(String command, OutputStream out)
	    throws RRDException, IOException {
	return m_singleton.doCommand(command, out);
    }
}
